package VR.my_util

import VR.OptionMap
import VR.alg.{SAGA, SVRG, AlgorithmBase}
import VR.data.PCA_Data
import java.io.File

import VR.prob.{ProblemBase, PCA_Problem}

/**
  * Created by YY on 2016/1/20.
  */
object PCA_worker extends Worker{


  def do_pca_work(options:OptionMap):Unit ={
    val mode:Int=options('PCA).toString.toInt
    val data_folder:String="D:\\Dropbox\\-SVN\\YuanYang-Zeyuan\\UniVR-dir\\PCA_Data\\"
    new File(data_folder).mkdir
    val n = options('n).toString.toInt
    val d= options('d).toString.toInt
    val n_d:String="-"+n+"-"+d
    val file_loc:String =data_folder+"output"+n_d+".txt"
    val helper_loc:String=data_folder+"output"+n_d+"-helper.txt"
    val full_matrix_loc:String=data_folder+"matrix"+n_d+".txt"
    if (mode!=0){
      val outputFolder="D:\\Dropbox\\-SVN\\YuanYang-Zeyuan\\UniVR-dir\\PCA-Mode"+mode+n_d+"-"+options('delta)+"\\"
      val use_alg="SVRG"
      val eta:Double = options('eta).toString.toDouble
      val scaled_value:Int=1000000
      val outputFileName:String= if (options.contains('get_ans)) "real_ans.txt"
          else mode+n_d+"-"+use_alg+"-"+(eta*scaled_value).toInt.toString
      if (new File(outputFolder+""+outputFileName).exists()  && (! options.contains('recompute))){
        println("File exists. Not recomputing.")
        return
      }
      val diagonal_matrix_loc:String=data_folder+"diagonal-"+mode+n_d+"-"+options('delta)+".txt"
      println("Mode="+mode)
      val gen_data:PCA_Data=new PCA_Data(mode,options('delta).toString.toDouble, file_loc=file_loc, helper_loc = helper_loc)
      gen_data.print_matrix(diagonal_matrix_loc, gen_data.matrix_D)
      gen_data.verify_sum_d()

      val success = new File(outputFolder).mkdirs()
      if (!success) println("Failed to make a new folder. It may already exist.")

      val tot_batch:Int=if (options.contains('get_ans)) 2000 else options('batch).toString.toInt+2
      val prob:ProblemBase[PCA_Data]= new PCA_Problem()
      val cur_alg:AlgorithmBase[PCA_Data]=
        use_alg match {
          case "SVRG"=> new SVRG(prob)
          case "SAGA" =>  new SAGA(prob)
        }
      cur_alg.train(gen_data,0,0,eta,tot_batch, Some(outputFolder+""+outputFileName))
      //cur_alg.print_vector(cur_alg.w, outputFolder+""+"w.txt")
      //cur_alg.print_sparse_vector(gen_data.random_b, outputFolder+""+"random_b.txt")
    }
    else{
      print("Generating..")
      println("n="+n+"  d="+d)
      val gen_data:PCA_Data=new PCA_Data(n,d)
      gen_data.print_few(print_to_file = file_loc, helper_file=helper_loc)
      gen_data.print_matrix(full_matrix_loc, gen_data.full_matrix)
      gen_data.print_norms()
    }
  }

}
