package VR.prob

import VR.data.DataClass

import scala.math.{exp, log}

/**
  * Created by YY on 2016/1/9.
  */
class LogisticRegression extends ProblemBase[DataClass]{

  override protected def row_objective_cal(w:Array[Double],data:DataClass, row:Int ):Double={
    val tmp:Double= exp(-data.y(row) * inner_sparse(w,data.x(row)))
    log(1.0+tmp)
  }
  override def gradient_cal(w:Array[Double],dat:DataClass, row:Int):Array[Double]={
    val tmp:Double= exp(-dat.y(row) * inner_sparse(w,dat.x(row)))
    val multi:Double= -dat.y(row)* (tmp/(1.0+tmp))
    val output=new Array[Double](dat.x(row).length)
    for (i<-dat.x(row).indices)
      output(i)=dat.x(row)(i)._2*multi
    output
  }

  override def binary_alpha_cal(alpha:Double, w: Array[Double], dat:DataClass, row:Int, lambda:Double, n:Int): Double = {
    var first:Double= -alpha+1e-4
    var last:Double= 1.0-alpha-1e-4
    var middle:Double=0
    var part1:Double=0
    val (x,_)=(dat.x(row), dat.y(row))
    for (iter<-x)
      part1+=w(iter._1) * iter._2
    var part2:Double=0
    for (iter<-x)
      part2 +=iter._2*iter._2
    part2*= 1.0/lambda/n
    while (last-first>=1e-12){
      middle=(first+last)/2
      val t1:Double = (-alpha-middle+1.0)/(alpha+middle)
      val t2:Double=math.exp(part1+part2*middle)
      if (t1-t2<0) last=middle else first=middle
    }
    (first+last)/2
  }

}
